# coding: utf-8

"""
    ChannelEngine Merchant API

    ChannelEngine API for merchants  # noqa: E501

    OpenAPI spec version: 2.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from channelengine_merchant_api_client.api_client import ApiClient


class NotificationApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def notification_index(self, **kwargs):  # noqa: E501
        """Get Notifications  # noqa: E501

        Gets all notifications based on filter  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.notification_index(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime from_date: Filter on the notification date, starting from this date. This date is inclusive.
        :param datetime to_date: Filter on the notification date, until this date. This date is exclusive.
        :param list[str] types: Notification type(s) to filter on
        :param list[str] merchant_order_nos: Filter on unique order reference used by the merchant
        :param list[str] channel_order_nos: Filter on unique order reference used by the channel
        :param list[str] merchant_return_nos: Filter on unique return reference used by the merchant
        :param list[str] channel_return_nos: Filter on unique return reference used by the channel
        :param list[str] merchant_shipment_nos: Filter on unique shipment reference used by the merchant
        :param int page: The page to filter on. Starts at 1.
        :return: CollectionOfMerchantNotificationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.notification_index_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.notification_index_with_http_info(**kwargs)  # noqa: E501
            return data

    def notification_index_with_http_info(self, **kwargs):  # noqa: E501
        """Get Notifications  # noqa: E501

        Gets all notifications based on filter  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.notification_index_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime from_date: Filter on the notification date, starting from this date. This date is inclusive.
        :param datetime to_date: Filter on the notification date, until this date. This date is exclusive.
        :param list[str] types: Notification type(s) to filter on
        :param list[str] merchant_order_nos: Filter on unique order reference used by the merchant
        :param list[str] channel_order_nos: Filter on unique order reference used by the channel
        :param list[str] merchant_return_nos: Filter on unique return reference used by the merchant
        :param list[str] channel_return_nos: Filter on unique return reference used by the channel
        :param list[str] merchant_shipment_nos: Filter on unique shipment reference used by the merchant
        :param int page: The page to filter on. Starts at 1.
        :return: CollectionOfMerchantNotificationResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['from_date', 'to_date', 'types', 'merchant_order_nos', 'channel_order_nos', 'merchant_return_nos', 'channel_return_nos', 'merchant_shipment_nos', 'page']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method notification_index" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'from_date' in params:
            query_params.append(('fromDate', params['from_date']))  # noqa: E501
        if 'to_date' in params:
            query_params.append(('toDate', params['to_date']))  # noqa: E501
        if 'types' in params:
            query_params.append(('types', params['types']))  # noqa: E501
            collection_formats['types'] = 'multi'  # noqa: E501
        if 'merchant_order_nos' in params:
            query_params.append(('merchantOrderNos', params['merchant_order_nos']))  # noqa: E501
            collection_formats['merchantOrderNos'] = 'multi'  # noqa: E501
        if 'channel_order_nos' in params:
            query_params.append(('channelOrderNos', params['channel_order_nos']))  # noqa: E501
            collection_formats['channelOrderNos'] = 'multi'  # noqa: E501
        if 'merchant_return_nos' in params:
            query_params.append(('merchantReturnNos', params['merchant_return_nos']))  # noqa: E501
            collection_formats['merchantReturnNos'] = 'multi'  # noqa: E501
        if 'channel_return_nos' in params:
            query_params.append(('channelReturnNos', params['channel_return_nos']))  # noqa: E501
            collection_formats['channelReturnNos'] = 'multi'  # noqa: E501
        if 'merchant_shipment_nos' in params:
            query_params.append(('merchantShipmentNos', params['merchant_shipment_nos']))  # noqa: E501
            collection_formats['merchantShipmentNos'] = 'multi'  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/v2/notifications', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CollectionOfMerchantNotificationResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
